Create Agent
Create an agent.
Body ParametersJSONExpand Collapse
Deprecatedbase_template_id: optional string
Deprecated: No longer used. The base template id of the agent.
compaction_settings: optional object { clip_chars, mode, model, 4 more }
Configuration for conversation compaction / summarization.
Per-model settings (temperature, max tokens, etc.) are derived from the default configuration for that handle.
clip_chars: optional number
The maximum length of the summary in characters. If none, no clipping is performed.
model: optional string
Model handle to use for sliding_window/all summarization (format: provider/model-name). If None, uses lightweight provider-specific defaults.
model_settings: optional OpenAIModelSettings { max_output_tokens, parallel_tool_calls, provider_type, 4 more } or object { max_output_tokens, parallel_tool_calls, provider_type, 5 more } or AnthropicModelSettings { effort, max_output_tokens, parallel_tool_calls, 6 more } or 14 more
Optional model settings used to override defaults for the summarizer model.
OpenAIModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 4 more }
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Sglang object { max_output_tokens, parallel_tool_calls, provider_type, 5 more }
SGLang model configuration (OpenAI-compatible runtime with SGLang-specific parsing).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
AnthropicModelSettings object { effort, max_output_tokens, parallel_tool_calls, 6 more }
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
strict: optional boolean
Enable strict mode for tool calling. When true, tool outputs are guaranteed to match JSON schemas.
GoogleAIModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
response_schema: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
GoogleVertexModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
response_schema: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
AzureModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Azure OpenAI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
XaiModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
xAI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Moonshot object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
Moonshot/Kimi model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Zai object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
Z.ai (ZhipuAI) model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
MoonshotCoding object { effort, max_output_tokens, parallel_tool_calls, 6 more }
Kimi Code model configuration (Anthropic-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
strict: optional boolean
Enable strict mode for tool calling. When true, tool outputs are guaranteed to match JSON schemas.
GroqModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Groq model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
DeepseekModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Deepseek model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
TogetherModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Together AI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
BedrockModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
AWS Bedrock model configuration.
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Baseten object { max_output_tokens, parallel_tool_calls, provider_type, temperature }
Baseten model configuration (OpenAI-compatible).
Openrouter object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
OpenRouter model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
embedding: optional string
The embedding model handle used by the agent (format: provider/model-name).
Deprecatedembedding_chunk_size: optional number
Deprecated: No longer used. The embedding chunk size used by the agent.
Deprecatedembedding_config: optional EmbeddingConfig { embedding_dim, embedding_endpoint_type, embedding_model, 7 more }
Deprecatedenable_reasoner: optional boolean
Deprecated: Use model field to configure reasoning instead. Whether to enable internal extended thinking step for a reasoner model.
enable_sleeptime: optional boolean
If set to True, memory management will move to a background agent thread.
Deprecatedfrom_template: optional string
Deprecated: please use the ‘create agents from a template’ endpoint instead.
Deprecatedhidden: optional boolean
Deprecated: No longer used. If set to True, the agent will be hidden.
include_base_tool_rules: optional boolean
If true, attaches the Letta base tool rules (e.g. deny all tools not explicitly allowed).
include_base_tools: optional boolean
If true, attaches the Letta core tools (e.g. core_memory related functions).
Deprecatedinclude_default_source: optional boolean
If true, automatically creates and attaches a default data source for this agent.
The initial set of messages to put in the agent’s in-context memory.
The content of the message.
array of LettaMessageContentUnion
ImageContent object { source, type }
source: object { url, type } or object { data, media_type, detail, type } or object { file_id, data, detail, 2 more }
The source of the image.
ToolCallContent object { id, input, name, 2 more }
ReasoningContent object { is_native, reasoning, signature, type }
Configuration for Language Model (LLM) connection and generation parameters.
.. deprecated:: LLMConfig is deprecated and should not be used as an input or return type in API calls. Use the schemas in letta.schemas.model (ModelSettings, OpenAIModelSettings, etc.) instead. For conversion, use the _to_model() method or Model._from_llm_config() method.
model_endpoint_type: "openai" or "anthropic" or "google_ai" or 27 more
The endpoint type for the model.
enable_reasoner: optional boolean
Whether or not the model should use extended thinking if it is a ‘reasoning’ style model
frequency_penalty: optional number
Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model’s likelihood to repeat the same line verbatim. From OpenAI: Number between -2.0 and 2.0.
max_reasoning_tokens: optional number
Configurable thinking budget for extended thinking. Used for enable_reasoner and also for Google Vertex models like Gemini 2.5 Flash. Minimum value is 1024 when used with enable_reasoner.
max_tokens: optional number
The maximum number of tokens to generate. If not set, the model will use its default value.
Deprecatedparallel_tool_calls: optional boolean
Deprecated: Use model_settings to configure parallel tool calls instead. If set to True, enables parallel tool calling. Defaults to False.
put_inner_thoughts_in_kwargs: optional boolean
Puts ‘inner_thoughts’ as a kwarg in the function call if this is set to True. This helps with function calling performance and also the generation of inner thoughts.
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
return_logprobs: optional boolean
Whether to return log probabilities of the output tokens. Useful for RL training.
return_token_ids: optional boolean
Whether to return token IDs for all LLM generations via SGLang native endpoint. Required for multi-turn RL training with loss masking. Only works with SGLang provider.
strict: optional boolean
Enable strict mode for tool calling. When true, tool schemas include strict: true and additionalProperties: false, guaranteeing tool outputs match JSON schemas.
temperature: optional number
The temperature to use when generating text with the model. A higher temperature will result in more random text.
tool_call_parser: optional string
SGLang tool call parser name (e.g. ‘glm47’, ‘qwen25’, ‘hermes’). Used by the SGLang native adapter to parse tool calls from raw model output.
max_files_open: optional number
Maximum number of files that can be open at once for this agent. Setting this too high may exceed the context window, which will break the agent.
Deprecatedmax_reasoning_tokens: optional number
Deprecated: Use model field to configure reasoning tokens instead. The maximum number of tokens to generate for reasoning step.
Deprecatedmax_tokens: optional number
Deprecated: Use model field to configure max output tokens instead. The maximum number of tokens to generate, including reasoning step.
Deprecatedmemory_variables: optional map[string]
Deprecated: Only relevant for creating agents from a template. Use the ‘create agents from a template’ endpoint instead.
message_buffer_autoclear: optional boolean
If set to True, the agent will not remember previous messages (though the agent will still retain state via core memory blocks and archival/recall memory). Not recommended unless you have an advanced use case.
model_settings: optional OpenAIModelSettings { max_output_tokens, parallel_tool_calls, provider_type, 4 more } or object { max_output_tokens, parallel_tool_calls, provider_type, 5 more } or AnthropicModelSettings { effort, max_output_tokens, parallel_tool_calls, 6 more } or 14 more
The model settings for the agent.
OpenAIModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 4 more }
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Sglang object { max_output_tokens, parallel_tool_calls, provider_type, 5 more }
SGLang model configuration (OpenAI-compatible runtime with SGLang-specific parsing).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
AnthropicModelSettings object { effort, max_output_tokens, parallel_tool_calls, 6 more }
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
strict: optional boolean
Enable strict mode for tool calling. When true, tool outputs are guaranteed to match JSON schemas.
GoogleAIModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
response_schema: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
GoogleVertexModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
response_schema: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
AzureModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Azure OpenAI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
XaiModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
xAI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Moonshot object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
Moonshot/Kimi model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Zai object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
Z.ai (ZhipuAI) model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
MoonshotCoding object { effort, max_output_tokens, parallel_tool_calls, 6 more }
Kimi Code model configuration (Anthropic-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
strict: optional boolean
Enable strict mode for tool calling. When true, tool outputs are guaranteed to match JSON schemas.
GroqModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Groq model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
DeepseekModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Deepseek model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
TogetherModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Together AI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
BedrockModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
AWS Bedrock model configuration.
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Baseten object { max_output_tokens, parallel_tool_calls, provider_type, temperature }
Baseten model configuration (OpenAI-compatible).
Openrouter object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
OpenRouter model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Deprecatedparallel_tool_calls: optional boolean
Deprecated: Use model_settings to configure parallel tool calls instead. If set to True, enables parallel tool calling.
per_file_view_window_char_limit: optional number
The per-file view window character limit for this agent. Setting this too high may exceed the context window, which will break the agent.
Deprecatedproject: optional string
Deprecated: Project should now be passed via the X-Project header instead of in the request body. If using the SDK, this can be done via the x_project parameter.
Deprecatedproject_id: optional string
Deprecated: No longer used. The id of the project the agent belongs to.
Deprecatedreasoning: optional boolean
Deprecated: Use model field to configure reasoning instead. Whether to enable reasoning for this agent.
Deprecatedresponse_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Deprecatedsource_ids: optional array of string
Deprecated: Use folder_ids field instead. The ids of the sources used by the agent.
Deprecatedtemplate_id: optional string
Deprecated: No longer used. The id of the template the agent belongs to.
Deprecatedtool_exec_environment_variables: optional map[string]
Deprecated: Use secrets field instead. Environment variables for tool execution.
tool_rules: optional array of ChildToolRule { children, tool_name, child_arg_nodes, 2 more } or InitToolRule { tool_name, args, prompt_template, type } or TerminalToolRule { tool_name, prompt_template, type } or 6 more
The tool rules governing the agent.
ChildToolRule object { children, tool_name, child_arg_nodes, 2 more }
InitToolRule object { tool_name, args, prompt_template, type }
Represents the initial tool rule configuration.
args: optional map[unknown]
Optional prefilled arguments for this tool. When present, these values will override any LLM-provided arguments with the same keys during invocation. Keys must match the tool’s parameter names and values must satisfy the tool’s JSON schema. Supports partial prefill; non-overlapping parameters are left to the model.
ConditionalToolRule object { child_output_mapping, tool_name, default_child, 3 more }
MaxCountPerStepToolRule object { max_count_limit, tool_name, prompt_template, type }
ParentToolRule object { children, tool_name, prompt_template, type }
A ToolRule that only allows a child tool to be called if the parent has been called.
ReturnsExpand Collapse
AgentState object { id, agent_type, blocks, 42 more }
Representation of an agent’s state. This is the state of the agent at a given time, and is persisted in the DB backend. The state has all the information needed to recreate a persisted agent.
Deprecated: Use model field instead. The LLM configuration used by the agent.
model_endpoint_type: "openai" or "anthropic" or "google_ai" or 27 more
The endpoint type for the model.
enable_reasoner: optional boolean
Whether or not the model should use extended thinking if it is a ‘reasoning’ style model
frequency_penalty: optional number
Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model’s likelihood to repeat the same line verbatim. From OpenAI: Number between -2.0 and 2.0.
max_reasoning_tokens: optional number
Configurable thinking budget for extended thinking. Used for enable_reasoner and also for Google Vertex models like Gemini 2.5 Flash. Minimum value is 1024 when used with enable_reasoner.
max_tokens: optional number
The maximum number of tokens to generate. If not set, the model will use its default value.
Deprecatedparallel_tool_calls: optional boolean
Deprecated: Use model_settings to configure parallel tool calls instead. If set to True, enables parallel tool calling. Defaults to False.
put_inner_thoughts_in_kwargs: optional boolean
Puts ‘inner_thoughts’ as a kwarg in the function call if this is set to True. This helps with function calling performance and also the generation of inner thoughts.
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
return_logprobs: optional boolean
Whether to return log probabilities of the output tokens. Useful for RL training.
return_token_ids: optional boolean
Whether to return token IDs for all LLM generations via SGLang native endpoint. Required for multi-turn RL training with loss masking. Only works with SGLang provider.
strict: optional boolean
Enable strict mode for tool calling. When true, tool schemas include strict: true and additionalProperties: false, guaranteeing tool outputs match JSON schemas.
temperature: optional number
The temperature to use when generating text with the model. A higher temperature will result in more random text.
tool_call_parser: optional string
SGLang tool call parser name (e.g. ‘glm47’, ‘qwen25’, ‘hermes’). Used by the SGLang native adapter to parse tool calls from raw model output.
Deprecatedmemory: object { blocks, agent_type, file_blocks, 2 more }
Deprecated: Use blocks field instead. The in-context memory of the agent.
file_blocks: optional array of object { file_id, is_open, source_id, 20 more }
Special blocks representing the agent’s in-context memory of an attached file
Deprecatedsources: array of object { id, embedding_config, name, 8 more }
Deprecated: Use folders field instead. The sources used by the agent.
embedding_config: EmbeddingConfig { embedding_dim, embedding_endpoint_type, embedding_model, 7 more }
The tools used by the agent.
default_requires_approval: optional boolean
Default value for whether or not executing this tool requires approval.
enable_parallel_execution: optional boolean
If set to True, then this tool will potentially be executed concurrently with other tools. Default False.
return_char_limit: optional number
The maximum number of characters in the response.
compaction_settings: optional object { clip_chars, mode, model, 4 more }
Configuration for conversation compaction / summarization.
Per-model settings (temperature, max tokens, etc.) are derived from the default configuration for that handle.
clip_chars: optional number
The maximum length of the summary in characters. If none, no clipping is performed.
model: optional string
Model handle to use for sliding_window/all summarization (format: provider/model-name). If None, uses lightweight provider-specific defaults.
model_settings: optional OpenAIModelSettings { max_output_tokens, parallel_tool_calls, provider_type, 4 more } or object { max_output_tokens, parallel_tool_calls, provider_type, 5 more } or AnthropicModelSettings { effort, max_output_tokens, parallel_tool_calls, 6 more } or 14 more
Optional model settings used to override defaults for the summarizer model.
OpenAIModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 4 more }
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Sglang object { max_output_tokens, parallel_tool_calls, provider_type, 5 more }
SGLang model configuration (OpenAI-compatible runtime with SGLang-specific parsing).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
AnthropicModelSettings object { effort, max_output_tokens, parallel_tool_calls, 6 more }
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
strict: optional boolean
Enable strict mode for tool calling. When true, tool outputs are guaranteed to match JSON schemas.
GoogleAIModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
response_schema: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
GoogleVertexModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
response_schema: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
AzureModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Azure OpenAI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
XaiModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
xAI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Moonshot object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
Moonshot/Kimi model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Zai object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
Z.ai (ZhipuAI) model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
MoonshotCoding object { effort, max_output_tokens, parallel_tool_calls, 6 more }
Kimi Code model configuration (Anthropic-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
strict: optional boolean
Enable strict mode for tool calling. When true, tool outputs are guaranteed to match JSON schemas.
GroqModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Groq model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
DeepseekModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Deepseek model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
TogetherModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Together AI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
BedrockModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
AWS Bedrock model configuration.
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Baseten object { max_output_tokens, parallel_tool_calls, provider_type, temperature }
Baseten model configuration (OpenAI-compatible).
Openrouter object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
OpenRouter model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
embedding: optional string
The embedding model handle used by the agent (format: provider/model-name).
Deprecatedembedding_config: optional EmbeddingConfig { embedding_dim, embedding_endpoint_type, embedding_model, 7 more }
enable_sleeptime: optional boolean
If set to True, memory management will move to a background agent thread.
identities: optional array of object { id, agent_ids, block_ids, 5 more }
Deprecatedidentity_ids: optional array of string
Deprecated: Use identities field instead. The ids of the identities associated with this agent.
last_run_completion: optional string
The timestamp when the agent last completed a run.
managed_group: optional object { id, agent_ids, description, 15 more }
The multi-agent group that this agent manages
max_message_buffer_length: optional number
The desired maximum length of messages in the context window of the convo agent. This is a best effort, and may be off slightly due to user/assistant interleaving.
max_files_open: optional number
Maximum number of files that can be open at once for this agent. Setting this too high may exceed the context window, which will break the agent.
message_buffer_autoclear: optional boolean
If set to True, the agent will not remember previous messages (though the agent will still retain state via core memory blocks and archival/recall memory). Not recommended unless you have an advanced use case.
model_settings: optional OpenAIModelSettings { max_output_tokens, parallel_tool_calls, provider_type, 4 more } or object { max_output_tokens, parallel_tool_calls, provider_type, 5 more } or AnthropicModelSettings { effort, max_output_tokens, parallel_tool_calls, 6 more } or 14 more
The model settings used by the agent.
OpenAIModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 4 more }
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Sglang object { max_output_tokens, parallel_tool_calls, provider_type, 5 more }
SGLang model configuration (OpenAI-compatible runtime with SGLang-specific parsing).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
AnthropicModelSettings object { effort, max_output_tokens, parallel_tool_calls, 6 more }
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
strict: optional boolean
Enable strict mode for tool calling. When true, tool outputs are guaranteed to match JSON schemas.
GoogleAIModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
response_schema: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
GoogleVertexModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
response_schema: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
AzureModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Azure OpenAI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
XaiModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
xAI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Moonshot object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
Moonshot/Kimi model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Zai object { max_output_tokens, parallel_tool_calls, provider_type, 3 more }
Z.ai (ZhipuAI) model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
MoonshotCoding object { effort, max_output_tokens, parallel_tool_calls, 6 more }
Kimi Code model configuration (Anthropic-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
strict: optional boolean
Enable strict mode for tool calling. When true, tool outputs are guaranteed to match JSON schemas.
GroqModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Groq model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
DeepseekModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Deepseek model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
TogetherModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
Together AI model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
BedrockModelSettings object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
AWS Bedrock model configuration.
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Baseten object { max_output_tokens, parallel_tool_calls, provider_type, temperature }
Baseten model configuration (OpenAI-compatible).
Openrouter object { max_output_tokens, parallel_tool_calls, provider_type, 2 more }
OpenRouter model configuration (OpenAI-compatible).
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Deprecatedmulti_agent_group: optional object { id, agent_ids, description, 15 more }
Deprecated: Use managed_group field instead. The multi-agent group that this agent manages.
max_message_buffer_length: optional number
The desired maximum length of messages in the context window of the convo agent. This is a best effort, and may be off slightly due to user/assistant interleaving.
A message representing a request for approval to call a tool (generated by the LLM to trigger tool execution).
Args: id (str): The ID of the message date (datetime): The date the message was created in ISO format name (Optional[str]): The name of the sender of the message tool_call (ToolCall): The tool call
Deprecatedtool_call: ToolCall { arguments, name, tool_call_id } or ToolCallDelta { arguments, name, tool_call_id }
The tool call that has been requested by the llm to run
otid: optional string
The offline threading id (OTID). Set by the client to deduplicate requests. Used for idempotency in background streaming mode — each message in a request must have a unique OTID. Retries of the same request should reuse the same OTIDs.
tool_calls: optional array of ToolCall { arguments, name, tool_call_id } or ToolCallDelta { arguments, name, tool_call_id }
The tool calls that have been requested by the llm to run, which are pending approval
array of ToolCall { arguments, name, tool_call_id }
per_file_view_window_char_limit: optional number
The per-file view window character limit for this agent. Setting this too high may exceed the context window, which will break the agent.
response_format: optional TextResponseFormat { type } or JsonSchemaResponseFormat { json_schema, type } or JsonObjectResponseFormat { type }
Deprecatedtool_exec_environment_variables: optional array of AgentEnvironmentVariable { agent_id, key, value, 7 more }
Deprecated: use secrets field instead.
tool_rules: optional array of ChildToolRule { children, tool_name, child_arg_nodes, 2 more } or InitToolRule { tool_name, args, prompt_template, type } or TerminalToolRule { tool_name, prompt_template, type } or 6 more
The list of tool rules.
ChildToolRule object { children, tool_name, child_arg_nodes, 2 more }
InitToolRule object { tool_name, args, prompt_template, type }
Represents the initial tool rule configuration.
args: optional map[unknown]
Optional prefilled arguments for this tool. When present, these values will override any LLM-provided arguments with the same keys during invocation. Keys must match the tool’s parameter names and values must satisfy the tool’s JSON schema. Supports partial prefill; non-overlapping parameters are left to the model.
ConditionalToolRule object { child_output_mapping, tool_name, default_child, 3 more }
MaxCountPerStepToolRule object { max_count_limit, tool_name, prompt_template, type }
ParentToolRule object { children, tool_name, prompt_template, type }
A ToolRule that only allows a child tool to be called if the parent has been called.
Create Agent
curl https://api.letta.com/v1/agents/ \
-H 'Content-Type: application/json' \
-H "Authorization: Bearer $LETTA_API_KEY" \
-d '{}'{
"id": "id",
"agent_type": "memgpt_agent",
"blocks": [
{
"value": "value",
"id": "block-123e4567-e89b-12d3-a456-426614174000",
"base_template_id": "base_template_id",
"created_by_id": "created_by_id",
"deployment_id": "deployment_id",
"description": "description",
"entity_id": "entity_id",
"hidden": true,
"is_template": true,
"label": "label",
"last_updated_by_id": "last_updated_by_id",
"limit": 0,
"metadata": {
"foo": "bar"
},
"preserve_on_migration": true,
"project_id": "project_id",
"read_only": true,
"tags": [
"string"
],
"template_id": "template_id",
"template_name": "template_name"
}
],
"llm_config": {
"context_window": 0,
"model": "model",
"model_endpoint_type": "openai",
"compatibility_type": "gguf",
"display_name": "display_name",
"effort": "low",
"enable_reasoner": true,
"frequency_penalty": 0,
"handle": "handle",
"max_reasoning_tokens": 0,
"max_tokens": 0,
"model_endpoint": "model_endpoint",
"model_wrapper": "model_wrapper",
"parallel_tool_calls": true,
"provider_category": "base",
"provider_name": "provider_name",
"put_inner_thoughts_in_kwargs": true,
"reasoning_effort": "none",
"response_format": {
"type": "text"
},
"return_logprobs": true,
"return_token_ids": true,
"strict": true,
"temperature": 0,
"tier": "tier",
"tool_call_parser": "tool_call_parser",
"top_logprobs": 0,
"verbosity": "low"
},
"memory": {
"blocks": [
{
"value": "value",
"id": "block-123e4567-e89b-12d3-a456-426614174000",
"base_template_id": "base_template_id",
"created_by_id": "created_by_id",
"deployment_id": "deployment_id",
"description": "description",
"entity_id": "entity_id",
"hidden": true,
"is_template": true,
"label": "label",
"last_updated_by_id": "last_updated_by_id",
"limit": 0,
"metadata": {
"foo": "bar"
},
"preserve_on_migration": true,
"project_id": "project_id",
"read_only": true,
"tags": [
"string"
],
"template_id": "template_id",
"template_name": "template_name"
}
],
"agent_type": "memgpt_agent",
"file_blocks": [
{
"file_id": "file_id",
"is_open": true,
"source_id": "source_id",
"value": "value",
"id": "block-123e4567-e89b-12d3-a456-426614174000",
"base_template_id": "base_template_id",
"created_by_id": "created_by_id",
"deployment_id": "deployment_id",
"description": "description",
"entity_id": "entity_id",
"hidden": true,
"is_template": true,
"label": "label",
"last_accessed_at": "2019-12-27T18:11:19.117Z",
"last_updated_by_id": "last_updated_by_id",
"limit": 0,
"metadata": {
"foo": "bar"
},
"preserve_on_migration": true,
"project_id": "project_id",
"read_only": true,
"tags": [
"string"
],
"template_id": "template_id",
"template_name": "template_name"
}
],
"git_enabled": true,
"prompt_template": "prompt_template"
},
"name": "name",
"sources": [
{
"id": "source-123e4567-e89b-12d3-a456-426614174000",
"embedding_config": {
"embedding_dim": 0,
"embedding_endpoint_type": "openai",
"embedding_model": "embedding_model",
"azure_deployment": "azure_deployment",
"azure_endpoint": "azure_endpoint",
"azure_version": "azure_version",
"batch_size": 0,
"embedding_chunk_size": 0,
"embedding_endpoint": "embedding_endpoint",
"handle": "handle"
},
"name": "name",
"created_at": "2019-12-27T18:11:19.117Z",
"created_by_id": "created_by_id",
"description": "description",
"instructions": "instructions",
"last_updated_by_id": "last_updated_by_id",
"metadata": {
"foo": "bar"
},
"updated_at": "2019-12-27T18:11:19.117Z",
"vector_db_provider": "native"
}
],
"system": "system",
"tags": [
"string"
],
"tools": [
{
"id": "tool-123e4567-e89b-12d3-a456-426614174000",
"args_json_schema": {
"foo": "bar"
},
"created_by_id": "created_by_id",
"default_requires_approval": true,
"description": "description",
"enable_parallel_execution": true,
"json_schema": {
"foo": "bar"
},
"last_updated_by_id": "last_updated_by_id",
"metadata_": {
"foo": "bar"
},
"name": "name",
"npm_requirements": [
{
"name": "x",
"version": "version"
}
],
"pip_requirements": [
{
"name": "x",
"version": "version"
}
],
"project_id": "project_id",
"return_char_limit": 1,
"source_code": "source_code",
"source_type": "source_type",
"tags": [
"string"
],
"tool_type": "custom"
}
],
"base_template_id": "base_template_id",
"compaction_settings": {
"clip_chars": 0,
"mode": "all",
"model": "model",
"model_settings": {
"max_output_tokens": 0,
"parallel_tool_calls": true,
"provider_type": "openai",
"reasoning": {
"reasoning_effort": "none"
},
"response_format": {
"type": "text"
},
"strict": true,
"temperature": 0
},
"prompt": "prompt",
"prompt_acknowledgement": true,
"sliding_window_percentage": 0
},
"created_at": "2019-12-27T18:11:19.117Z",
"created_by_id": "created_by_id",
"deployment_id": "deployment_id",
"description": "description",
"embedding": "embedding",
"embedding_config": {
"embedding_dim": 0,
"embedding_endpoint_type": "openai",
"embedding_model": "embedding_model",
"azure_deployment": "azure_deployment",
"azure_endpoint": "azure_endpoint",
"azure_version": "azure_version",
"batch_size": 0,
"embedding_chunk_size": 0,
"embedding_endpoint": "embedding_endpoint",
"handle": "handle"
},
"enable_sleeptime": true,
"entity_id": "entity_id",
"hidden": true,
"identities": [
{
"id": "identity-123e4567-e89b-12d3-a456-426614174000",
"agent_ids": [
"string"
],
"block_ids": [
"string"
],
"identifier_key": "identifier_key",
"identity_type": "org",
"name": "name",
"project_id": "project_id",
"properties": [
{
"key": "key",
"type": "string",
"value": "string"
}
]
}
],
"identity_ids": [
"string"
],
"last_run_completion": "2019-12-27T18:11:19.117Z",
"last_run_duration_ms": 0,
"last_stop_reason": "end_turn",
"last_updated_by_id": "last_updated_by_id",
"managed_group": {
"id": "id",
"agent_ids": [
"string"
],
"description": "description",
"manager_type": "round_robin",
"base_template_id": "base_template_id",
"deployment_id": "deployment_id",
"hidden": true,
"last_processed_message_id": "last_processed_message_id",
"manager_agent_id": "manager_agent_id",
"max_message_buffer_length": 0,
"max_turns": 0,
"min_message_buffer_length": 0,
"project_id": "project_id",
"shared_block_ids": [
"string"
],
"sleeptime_agent_frequency": 0,
"template_id": "template_id",
"termination_token": "termination_token",
"turns_counter": 0
},
"max_files_open": 0,
"message_buffer_autoclear": true,
"message_ids": [
"string"
],
"metadata": {
"foo": "bar"
},
"model": "model",
"model_settings": {
"max_output_tokens": 0,
"parallel_tool_calls": true,
"provider_type": "openai",
"reasoning": {
"reasoning_effort": "none"
},
"response_format": {
"type": "text"
},
"strict": true,
"temperature": 0
},
"multi_agent_group": {
"id": "id",
"agent_ids": [
"string"
],
"description": "description",
"manager_type": "round_robin",
"base_template_id": "base_template_id",
"deployment_id": "deployment_id",
"hidden": true,
"last_processed_message_id": "last_processed_message_id",
"manager_agent_id": "manager_agent_id",
"max_message_buffer_length": 0,
"max_turns": 0,
"min_message_buffer_length": 0,
"project_id": "project_id",
"shared_block_ids": [
"string"
],
"sleeptime_agent_frequency": 0,
"template_id": "template_id",
"termination_token": "termination_token",
"turns_counter": 0
},
"pending_approval": {
"id": "id",
"date": "2019-12-27T18:11:19.117Z",
"tool_call": {
"arguments": "arguments",
"name": "name",
"tool_call_id": "tool_call_id"
},
"is_err": true,
"message_type": "approval_request_message",
"name": "name",
"otid": "otid",
"run_id": "run_id",
"sender_id": "sender_id",
"seq_id": 0,
"step_id": "step_id",
"tool_calls": [
{
"arguments": "arguments",
"name": "name",
"tool_call_id": "tool_call_id"
}
]
},
"per_file_view_window_char_limit": 0,
"project_id": "project_id",
"response_format": {
"type": "text"
},
"secrets": [
{
"agent_id": "agent_id",
"key": "key",
"value": "value",
"id": "agent-env-123e4567-e89b-12d3-a456-426614174000",
"created_at": "2019-12-27T18:11:19.117Z",
"created_by_id": "created_by_id",
"description": "description",
"last_updated_by_id": "last_updated_by_id",
"updated_at": "2019-12-27T18:11:19.117Z",
"value_enc": "value_enc"
}
],
"template_id": "template_id",
"timezone": "timezone",
"tool_exec_environment_variables": [
{
"agent_id": "agent_id",
"key": "key",
"value": "value",
"id": "agent-env-123e4567-e89b-12d3-a456-426614174000",
"created_at": "2019-12-27T18:11:19.117Z",
"created_by_id": "created_by_id",
"description": "description",
"last_updated_by_id": "last_updated_by_id",
"updated_at": "2019-12-27T18:11:19.117Z",
"value_enc": "value_enc"
}
],
"tool_rules": [
{
"children": [
"string"
],
"tool_name": "tool_name",
"child_arg_nodes": [
{
"name": "name",
"args": {
"foo": "bar"
}
}
],
"prompt_template": "prompt_template",
"type": "constrain_child_tools"
}
],
"updated_at": "2019-12-27T18:11:19.117Z"
}Returns Examples
{
"id": "id",
"agent_type": "memgpt_agent",
"blocks": [
{
"value": "value",
"id": "block-123e4567-e89b-12d3-a456-426614174000",
"base_template_id": "base_template_id",
"created_by_id": "created_by_id",
"deployment_id": "deployment_id",
"description": "description",
"entity_id": "entity_id",
"hidden": true,
"is_template": true,
"label": "label",
"last_updated_by_id": "last_updated_by_id",
"limit": 0,
"metadata": {
"foo": "bar"
},
"preserve_on_migration": true,
"project_id": "project_id",
"read_only": true,
"tags": [
"string"
],
"template_id": "template_id",
"template_name": "template_name"
}
],
"llm_config": {
"context_window": 0,
"model": "model",
"model_endpoint_type": "openai",
"compatibility_type": "gguf",
"display_name": "display_name",
"effort": "low",
"enable_reasoner": true,
"frequency_penalty": 0,
"handle": "handle",
"max_reasoning_tokens": 0,
"max_tokens": 0,
"model_endpoint": "model_endpoint",
"model_wrapper": "model_wrapper",
"parallel_tool_calls": true,
"provider_category": "base",
"provider_name": "provider_name",
"put_inner_thoughts_in_kwargs": true,
"reasoning_effort": "none",
"response_format": {
"type": "text"
},
"return_logprobs": true,
"return_token_ids": true,
"strict": true,
"temperature": 0,
"tier": "tier",
"tool_call_parser": "tool_call_parser",
"top_logprobs": 0,
"verbosity": "low"
},
"memory": {
"blocks": [
{
"value": "value",
"id": "block-123e4567-e89b-12d3-a456-426614174000",
"base_template_id": "base_template_id",
"created_by_id": "created_by_id",
"deployment_id": "deployment_id",
"description": "description",
"entity_id": "entity_id",
"hidden": true,
"is_template": true,
"label": "label",
"last_updated_by_id": "last_updated_by_id",
"limit": 0,
"metadata": {
"foo": "bar"
},
"preserve_on_migration": true,
"project_id": "project_id",
"read_only": true,
"tags": [
"string"
],
"template_id": "template_id",
"template_name": "template_name"
}
],
"agent_type": "memgpt_agent",
"file_blocks": [
{
"file_id": "file_id",
"is_open": true,
"source_id": "source_id",
"value": "value",
"id": "block-123e4567-e89b-12d3-a456-426614174000",
"base_template_id": "base_template_id",
"created_by_id": "created_by_id",
"deployment_id": "deployment_id",
"description": "description",
"entity_id": "entity_id",
"hidden": true,
"is_template": true,
"label": "label",
"last_accessed_at": "2019-12-27T18:11:19.117Z",
"last_updated_by_id": "last_updated_by_id",
"limit": 0,
"metadata": {
"foo": "bar"
},
"preserve_on_migration": true,
"project_id": "project_id",
"read_only": true,
"tags": [
"string"
],
"template_id": "template_id",
"template_name": "template_name"
}
],
"git_enabled": true,
"prompt_template": "prompt_template"
},
"name": "name",
"sources": [
{
"id": "source-123e4567-e89b-12d3-a456-426614174000",
"embedding_config": {
"embedding_dim": 0,
"embedding_endpoint_type": "openai",
"embedding_model": "embedding_model",
"azure_deployment": "azure_deployment",
"azure_endpoint": "azure_endpoint",
"azure_version": "azure_version",
"batch_size": 0,
"embedding_chunk_size": 0,
"embedding_endpoint": "embedding_endpoint",
"handle": "handle"
},
"name": "name",
"created_at": "2019-12-27T18:11:19.117Z",
"created_by_id": "created_by_id",
"description": "description",
"instructions": "instructions",
"last_updated_by_id": "last_updated_by_id",
"metadata": {
"foo": "bar"
},
"updated_at": "2019-12-27T18:11:19.117Z",
"vector_db_provider": "native"
}
],
"system": "system",
"tags": [
"string"
],
"tools": [
{
"id": "tool-123e4567-e89b-12d3-a456-426614174000",
"args_json_schema": {
"foo": "bar"
},
"created_by_id": "created_by_id",
"default_requires_approval": true,
"description": "description",
"enable_parallel_execution": true,
"json_schema": {
"foo": "bar"
},
"last_updated_by_id": "last_updated_by_id",
"metadata_": {
"foo": "bar"
},
"name": "name",
"npm_requirements": [
{
"name": "x",
"version": "version"
}
],
"pip_requirements": [
{
"name": "x",
"version": "version"
}
],
"project_id": "project_id",
"return_char_limit": 1,
"source_code": "source_code",
"source_type": "source_type",
"tags": [
"string"
],
"tool_type": "custom"
}
],
"base_template_id": "base_template_id",
"compaction_settings": {
"clip_chars": 0,
"mode": "all",
"model": "model",
"model_settings": {
"max_output_tokens": 0,
"parallel_tool_calls": true,
"provider_type": "openai",
"reasoning": {
"reasoning_effort": "none"
},
"response_format": {
"type": "text"
},
"strict": true,
"temperature": 0
},
"prompt": "prompt",
"prompt_acknowledgement": true,
"sliding_window_percentage": 0
},
"created_at": "2019-12-27T18:11:19.117Z",
"created_by_id": "created_by_id",
"deployment_id": "deployment_id",
"description": "description",
"embedding": "embedding",
"embedding_config": {
"embedding_dim": 0,
"embedding_endpoint_type": "openai",
"embedding_model": "embedding_model",
"azure_deployment": "azure_deployment",
"azure_endpoint": "azure_endpoint",
"azure_version": "azure_version",
"batch_size": 0,
"embedding_chunk_size": 0,
"embedding_endpoint": "embedding_endpoint",
"handle": "handle"
},
"enable_sleeptime": true,
"entity_id": "entity_id",
"hidden": true,
"identities": [
{
"id": "identity-123e4567-e89b-12d3-a456-426614174000",
"agent_ids": [
"string"
],
"block_ids": [
"string"
],
"identifier_key": "identifier_key",
"identity_type": "org",
"name": "name",
"project_id": "project_id",
"properties": [
{
"key": "key",
"type": "string",
"value": "string"
}
]
}
],
"identity_ids": [
"string"
],
"last_run_completion": "2019-12-27T18:11:19.117Z",
"last_run_duration_ms": 0,
"last_stop_reason": "end_turn",
"last_updated_by_id": "last_updated_by_id",
"managed_group": {
"id": "id",
"agent_ids": [
"string"
],
"description": "description",
"manager_type": "round_robin",
"base_template_id": "base_template_id",
"deployment_id": "deployment_id",
"hidden": true,
"last_processed_message_id": "last_processed_message_id",
"manager_agent_id": "manager_agent_id",
"max_message_buffer_length": 0,
"max_turns": 0,
"min_message_buffer_length": 0,
"project_id": "project_id",
"shared_block_ids": [
"string"
],
"sleeptime_agent_frequency": 0,
"template_id": "template_id",
"termination_token": "termination_token",
"turns_counter": 0
},
"max_files_open": 0,
"message_buffer_autoclear": true,
"message_ids": [
"string"
],
"metadata": {
"foo": "bar"
},
"model": "model",
"model_settings": {
"max_output_tokens": 0,
"parallel_tool_calls": true,
"provider_type": "openai",
"reasoning": {
"reasoning_effort": "none"
},
"response_format": {
"type": "text"
},
"strict": true,
"temperature": 0
},
"multi_agent_group": {
"id": "id",
"agent_ids": [
"string"
],
"description": "description",
"manager_type": "round_robin",
"base_template_id": "base_template_id",
"deployment_id": "deployment_id",
"hidden": true,
"last_processed_message_id": "last_processed_message_id",
"manager_agent_id": "manager_agent_id",
"max_message_buffer_length": 0,
"max_turns": 0,
"min_message_buffer_length": 0,
"project_id": "project_id",
"shared_block_ids": [
"string"
],
"sleeptime_agent_frequency": 0,
"template_id": "template_id",
"termination_token": "termination_token",
"turns_counter": 0
},
"pending_approval": {
"id": "id",
"date": "2019-12-27T18:11:19.117Z",
"tool_call": {
"arguments": "arguments",
"name": "name",
"tool_call_id": "tool_call_id"
},
"is_err": true,
"message_type": "approval_request_message",
"name": "name",
"otid": "otid",
"run_id": "run_id",
"sender_id": "sender_id",
"seq_id": 0,
"step_id": "step_id",
"tool_calls": [
{
"arguments": "arguments",
"name": "name",
"tool_call_id": "tool_call_id"
}
]
},
"per_file_view_window_char_limit": 0,
"project_id": "project_id",
"response_format": {
"type": "text"
},
"secrets": [
{
"agent_id": "agent_id",
"key": "key",
"value": "value",
"id": "agent-env-123e4567-e89b-12d3-a456-426614174000",
"created_at": "2019-12-27T18:11:19.117Z",
"created_by_id": "created_by_id",
"description": "description",
"last_updated_by_id": "last_updated_by_id",
"updated_at": "2019-12-27T18:11:19.117Z",
"value_enc": "value_enc"
}
],
"template_id": "template_id",
"timezone": "timezone",
"tool_exec_environment_variables": [
{
"agent_id": "agent_id",
"key": "key",
"value": "value",
"id": "agent-env-123e4567-e89b-12d3-a456-426614174000",
"created_at": "2019-12-27T18:11:19.117Z",
"created_by_id": "created_by_id",
"description": "description",
"last_updated_by_id": "last_updated_by_id",
"updated_at": "2019-12-27T18:11:19.117Z",
"value_enc": "value_enc"
}
],
"tool_rules": [
{
"children": [
"string"
],
"tool_name": "tool_name",
"child_arg_nodes": [
{
"name": "name",
"args": {
"foo": "bar"
}
}
],
"prompt_template": "prompt_template",
"type": "constrain_child_tools"
}
],
"updated_at": "2019-12-27T18:11:19.117Z"
}